# Hướng dẫn sử dụng ssh-tool.
ssh-tool là ứng dụng viết bằng python và trên thư viện netmiko để chạy 1 tập lệnh cho 1 tập các thiết bị nhằm mục đích tiết kiệm thời gian và tránh sai sót khi cấu hình cùng lúc nhiều thiết bị theo một kịch bản (tập lệnh) cố định. 
Tool có thể chạy trên tất cả các HĐH miễn là có thể cài đặt python và các gói liên quan.

[[_TOC_]]

## I. Download source code

Để chạy ứng dụng thì ta cần download mã nguồn về máy để chạy, có 2 phương pháp

### 1. Dùng git

Nếu đã biết các sử dụng git thì dùng git để download mã nguồn về

*git clone https://gitlab.awing.vn/awing-public/sshtool.git*


### 2. Download thủ công

Nếu không dùng git thì có thể download thẳng source code về máy, cũng tương tự như dùng git

Trong cả 2 trường hợp, giả sử rằng thư mục source code đã download về máy là C:\\sshtool\>

## II. Thiết lập thông số

### 1. File hosts.txt

Chứa thông tin về host, dữ liệu đầu vào theo chuẩn csv, các trường dữ liệu cách nhau vởi dấu *,*

Thông tin các trường dữ liệu như sau :
- name : Là tên định danh thiết bị
- device_type : Loại thiết bị, lưu ý chọn đúng kiểu thiết bị. Tham khảo thêm tại https://github.com/ktbyers/netmiko/blob/develop/PLATFORMS.md.

Có thể hỗ trợ device_type là autodetect để tự động nhận dạng loại thiết bị, tuy nhiên ko recommend vì nhiều lúc chức năng này hoạt động ko chính xác, nếu có thể thì input chính xác device_type theo danh sách trên.
- host : ip truy cập
- username : username truy cập
- password : mật khẩu truy cập
- port : Cổng kết nối, thường là 22

### 2. File commands.txt

Chứa tập lệnh cần chạy, cũng theo chuẩn csv giống như file hosts, có các trường dữ liệu như sau
- command : Lệnh cần thực thi

Các lệnh đặc biệt #enable_mode, #exit_enable_mode, #config_mode, #exit_config_mode để đưa thiết bị vào trạng thái enable hay config mode 
- expect_string : Đoạn string pattern regex cần tìm trong kết quả trả về để xác định là command đã hoàn thành, nếu để trống thì được hiểu là so sánh với dấu nhắc mặc định của thiết bị. Thường dùng nếu các câu lệnh thay đổi dấu nhắc của thiết bị hoặc các trường hợp kết quả trả về không chứa dấu nhắc mặc đinh của thiết bị (ví dụ yêu cầu confirm, yêu cầu input thêm thông tin, ..)

Ví dụ thiết bị mikrotik_routeros gửi command như sau 

*/ip hotspot walled-garden*

Thì dấu nhắc mới có thể là 

*[admin@MikroTik] /ip hotspot walled-garden>*

Thì expect_string có thể là *walled-garden>*

### 3. File log.txt

Chứa log kết quả chạy cho toàn bộ thiết bị

### 4. Thư mục output_dir

Chứa toàn bộ file log thực thi, mỗi thiết bị là 1 file với tên file là tên thiết bị được xác định bởi trường name trong file hosts.txt

### 5. File config.py

Về cơ bản có thể chạy các ứng dụng với các thông số mặc định. Nếu người dùng cần tùy chỉnh các thông số thì điều chỉnh ở file này. File này chứa cấu hình đường dẫn các file trên, có thể đổi tên file hay đường dẫn nếu muốn. Ngoài ra có format ghi file log, có thể điều chỉnh thêm thời gian ghi log nếu muốn bằng cách chỉnh lại định dạng log format (tham khảo thêm tại https://realpython.com/python-logging/)

## III. Cài đặt và chạy ứng dụng

### 1. Cài đặt python

Để chạy ứng dụng, ta cài đặt python version 3.7 trở lên. Truy cập https://www.python.org/ và tìm gói cài đặt tương ứng, sau khi cài đặt thành công thì kiểm tra xem python đã hoạt động chưa bằng cách mở command và gõ lệnh

*C:\\>python*

Nếu hiển thị thông tin version và dấu nhắc >>> thì nghĩa là đã cài đặt thành công, ví dụ

\>\>\> *Python 3.7.9 (tags/v3.7.9:13c94747c7, Aug 17 2020, 18:58:18) [MSC v.1900 64 bit (AMD64)] on win32*
*Type "help", "copyright", "credits" or "license" for more information.*

### 2. Cài đặt pip

PIP (Preferred Installer Program), là trình quản lý package trên python, đa phần khi cài đặt python thì đã kèm pip, để kiểm tra ta mở command và gõ lệnh

*C:\\>pip -V*

Nếu hiển thị thông tin version nghĩa là đã có sẵn pip

*pip 22.0.4 from D:\Python37\lib\site-packages\pip (python 3.7)*

Ngược lại thì ta phải cài đặt pip, tham khảo và cài đặt tại đường dẫn https://pip.pypa.io/en/stable/installation/

### 3. Cài đặt các gói cần thiết để chạy ứng dụng

Mở command, enter vào thư mục chứa ứng dụng và chạy lệnh sau để cài đặt các gói

*C:\\sshtool\>pip install -r requirements.txt --no-cache-dir --compile*

### 4. Chạy ứng dụng

Mở command, enter vào thư mục chứa ứng dụng và chạy lệnh sau để chạy ứng dụng

*C:\\sshtool\>python app.py*